﻿using Microsoft.AspNetCore.Components;
using WF_WebAdmin.Service;
using WF_WebAdmin.Model;
using Microsoft.AspNetCore.Mvc;
using System.Text.RegularExpressions;


namespace WF_WebAdmin.Pages
{
    public partial class AddQuiz
    {
        [Inject]
        private IQuizService quizService { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }

        private QuizModel QuizModel = new();

        private async void HandleValidSubmit()
        {
            
            int id;
            id = await quizService.getNbQuiz();
            id++;
            await quizService.addQuiz(new Quiz(
                id,
                validateInformation(QuizModel.Question),
                validateInformation(QuizModel.AnswerA),
                validateInformation(QuizModel.AnswerB),
                validateInformation(QuizModel.AnswerC),
                validateInformation(QuizModel.AnswerD),
                validateReponse(QuizModel.CAnswer)
            ));
            NavigationManager.NavigateTo("modifquiz");
        }

        private void OnCAwnserChange(string item, object checkedValue)
        {
            QuizModel.CAnswer = item;
        }

        private static string validateInformation(string item)
        {
            return item; // VALIDATION A FAIRE
        }

        private static string validateReponse(string item) 
        {
            try
            {
                if (!string.IsNullOrEmpty(item))
                {
                    switch (item)
                    {
                        case "A":
                            break;
                        case "B":
                            break;
                        case "C":
                            break;
                        case "D":
                            break;
                        default:
                            throw new InvalidDataException("Invalid item (validateReponse) : item must be A,B,C or D " + item + "give.");
                    }
                }
                else
                {
                    throw new ArgumentNullException("Invalid item (validateReponse): null given.");
                }
                return item;
            }
            catch (Exception ex) 
            {
                return "A"; //Default Argument
            }
        }
    }
}
