﻿using Blazorise.DataGrid;
using Microsoft.AspNetCore.Components;
using Microsoft.Extensions.Configuration.UserSecrets;
using WF_WebAdmin.Model;
using WF_WebAdmin.Service;

namespace WF_WebAdmin.Pages
{
    public partial class DeleteUser
    {
        private bool showDeletePopup = false;
        private bool showModifyPopup = false;
        private User userToDelete = null;
        private User selectedUser;
        private bool showPopupDelete = false;
        private bool showPopupAdmin = false;
        private User userToAdmin = null;
        private int MaxValue = 5;
        private int totalItem;
        private int page = 1;


        [Inject]
        public HttpClient Http { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }
        
        private List<User> users;

        [Inject]
        private IUserService userService { get; set; }



        protected override async Task OnInitializedAsync()
        {
            users = await userService.getSomeUser(MaxValue, 1);
        }

        private async Task OnReadData(DataGridReadDataEventArgs<User> e)
        {
            if (e.CancellationToken.IsCancellationRequested)
            {
                return;
            }


            var response = await userService.getSomeUser(e.PageSize, e.Page);

            if (!e.CancellationToken.IsCancellationRequested)
            {
                totalItem = await userService.getNbUser();
                users = new List<User>(response.ToArray());
                page = e.Page;
            }
        }

        // ------- Popup remove user -------
        private void ShowConfirmation(User user)
        {
            userToDelete = user;
            showPopupDelete = true;
        }

        private void ShowModifyConfirmation(User user)
        {
            // Afficher la modale et mémoriser l'utilisateur à supprimer
            selectedUser = user;
            showModifyPopup = true;
        }

        private async Task RemoveUser()
        {
            if (userToDelete != null)
            {
                await userService.removeUser(userToDelete);
                ClosePopup();
                var response = await userService.getSomeUser(MaxValue, page);
                users = new List<User>(response.ToArray());
            }
        }

        private async Task ModifyUser()
        {
            await userService.updateUser(selectedUser);
            ClosePopup();
        }

        private void ClosePopup()
        {
            showDeletePopup = false;
            showModifyPopup = false;
            showPopupDelete = false;
            showPopupAdmin = false;
        }


        // ------- Popup admin -------
        private void ShowConfirmationAdmin(User user)
        {
            userToAdmin = user;
            showPopupAdmin = true;
        }



        private async Task setAdmin()
        {
            if (!userToAdmin.IsAdmin)
            {
                userToAdmin.IsAdmin = true;
                await userService.updateUser(userToAdmin);
                ClosePopup();
            }
            else
            {
                userToAdmin.IsAdmin = false;
                await userService.updateUser(userToAdmin);
                ClosePopup();
            }
        }

    }
}
