using Blazorise.DataGrid;
using Microsoft.AspNetCore.Components;
using WF_WebAdmin.Model;
using WF_WebAdmin.Service;

namespace WF_WebAdmin.Pages
{
    public partial class ModifQuote
    {
        private Quote[] quotes;

        private int MaxValue = 5;

        private int totalItem;
        
        /*private bool showEditQuote = false;*/
        
        private Quote? selectedQuote;

        private bool showPopupDelete = false;

        private int page = 1;

        [Inject]
        public IQuoteService QuoteService { get; set; }

        private async Task OnReadData(DataGridReadDataEventArgs<Quote> e)
        {
            if (e.CancellationToken.IsCancellationRequested)
            {
                return;
            }

            var response = await QuoteService.getSomeQuote(e.PageSize, e.Page);

            if (!e.CancellationToken.IsCancellationRequested)
            {
                totalItem = await QuoteService.getNbQuote();
                quotes = response.ToArray();
                page = e.Page;
            }
        }

        /*private void OnEditButtonClicked(Quote quote)
        {
            if (selectedQuote == null) return;
            selectedQuote = quote;
            showEditQuote = true;
        }*/
        
        private void ClosePopup()
        {
            /*showEditQuote = false;*/
            showPopupDelete = false;
            selectedQuote = null;
        }

        /*private async Task EditQuote()
        {
            await QuoteService.updateQuote(selectedQuote);
            selectedQuote = null;
            ClosePopup();
        }*/

        private void OnDelete(Quote q)
        {
            selectedQuote = q;
            showPopupDelete = true;
        }

        private async void RemoveQuote()
        {
            if (selectedQuote != null)
            {
                await QuoteService.removeQuote(selectedQuote);
                selectedQuote= null;
                var response = await QuoteService.getSomeQuote(MaxValue, page);
                quotes = response.ToArray();
            }
            showPopupDelete= false;
        }
    }
}
